'use strict';

import test from 'ava';
import convert from '../index';

test('convert supported attributes', t => {
  t.is(convert('accept'), 'accept');
  t.is(convert('acceptcharset'), 'acceptCharset');
  t.is(convert('accesskey'), 'accessKey');
  t.is(convert('action'), 'action');
  t.is(convert('allowfullscreen'), 'allowFullScreen');
  t.is(convert('allowtransparency'), 'allowTransparency');
  t.is(convert('alt'), 'alt');
  t.is(convert('async'), 'async');
  t.is(convert('autocomplete'), 'autoComplete');
  t.is(convert('autofocus'), 'autoFocus');
  t.is(convert('autoplay'), 'autoPlay');
  t.is(convert('capture'), 'capture');
  t.is(convert('cellpadding'), 'cellPadding');
  t.is(convert('cellspacing'), 'cellSpacing');
  t.is(convert('charset'), 'charSet');
  t.is(convert('challenge'), 'challenge');
  t.is(convert('checked'), 'checked');
  t.is(convert('classid'), 'classID');
  t.is(convert('class'), 'className');
  t.is(convert('cols'), 'cols');
  t.is(convert('colspan'), 'colSpan');
  t.is(convert('content'), 'content');
  t.is(convert('contenteditable'), 'contentEditable');
  t.is(convert('contextmenu'), 'contextMenu');
  t.is(convert('controls'), 'controls');
  t.is(convert('coords'), 'coords');
  t.is(convert('crossorigin'), 'crossOrigin');
  t.is(convert('data'), 'data');
  t.is(convert('datetime'), 'dateTime');
  t.is(convert('defer'), 'defer');
  t.is(convert('dir'), 'dir');
  t.is(convert('disabled'), 'disabled');
  t.is(convert('download'), 'download');
  t.is(convert('draggable'), 'draggable');
  t.is(convert('enctype'), 'encType');
  t.is(convert('form'), 'form');
  t.is(convert('formaction'), 'formAction');
  t.is(convert('formenctype'), 'formEncType');
  t.is(convert('formmethod'), 'formMethod');
  t.is(convert('formnovalidate'), 'formNoValidate');
  t.is(convert('formtarget'), 'formTarget');
  t.is(convert('frameborder'), 'frameBorder');
  t.is(convert('headers'), 'headers');
  t.is(convert('height'), 'height');
  t.is(convert('hidden'), 'hidden');
  t.is(convert('high'), 'high');
  t.is(convert('href'), 'href');
  t.is(convert('hreflang'), 'hrefLang');
  t.is(convert('for'), 'htmlFor');
  t.is(convert('httpequiv'), 'httpEquiv');
  t.is(convert('icon'), 'icon');
  t.is(convert('id'), 'id');
  t.is(convert('inputmode'), 'inputMode');
  t.is(convert('keyparams'), 'keyParams');
  t.is(convert('keytype'), 'keyType');
  t.is(convert('label'), 'label');
  t.is(convert('lang'), 'lang');
  t.is(convert('list'), 'list');
  t.is(convert('loop'), 'loop');
  t.is(convert('low'), 'low');
  t.is(convert('manifest'), 'manifest');
  t.is(convert('marginheight'), 'marginHeight');
  t.is(convert('marginwidth'), 'marginWidth');
  t.is(convert('max'), 'max');
  t.is(convert('maxlength'), 'maxLength');
  t.is(convert('media'), 'media');
  t.is(convert('mediagroup'), 'mediaGroup');
  t.is(convert('method'), 'method');
  t.is(convert('min'), 'min');
  t.is(convert('minlength'), 'minLength');
  t.is(convert('multiple'), 'multiple');
  t.is(convert('muted'), 'muted');
  t.is(convert('name'), 'name');
  t.is(convert('novalidate'), 'noValidate');
  t.is(convert('open'), 'open');
  t.is(convert('optimum'), 'optimum');
  t.is(convert('pattern'), 'pattern');
  t.is(convert('placeholder'), 'placeholder');
  t.is(convert('poster'), 'poster');
  t.is(convert('preload'), 'preload');
  t.is(convert('radiogroup'), 'radioGroup');
  t.is(convert('readonly'), 'readOnly');
  t.is(convert('rel'), 'rel');
  t.is(convert('required'), 'required');
  t.is(convert('role'), 'role');
  t.is(convert('rows'), 'rows');
  t.is(convert('rowspan'), 'rowSpan');
  t.is(convert('sandbox'), 'sandbox');
  t.is(convert('scope'), 'scope');
  t.is(convert('scoped'), 'scoped');
  t.is(convert('scrolling'), 'scrolling');
  t.is(convert('seamless'), 'seamless');
  t.is(convert('selected'), 'selected');
  t.is(convert('shape'), 'shape');
  t.is(convert('size'), 'size');
  t.is(convert('sizes'), 'sizes');
  t.is(convert('span'), 'span');
  t.is(convert('spellcheck'), 'spellCheck');
  t.is(convert('src'), 'src');
  t.is(convert('srcdoc'), 'srcDoc');
  t.is(convert('srcset'), 'srcSet');
  t.is(convert('start'), 'start');
  t.is(convert('step'), 'step');
  t.is(convert('style'), 'style');
  t.is(convert('summary'), 'summary');
  t.is(convert('tabindex'), 'tabIndex');
  t.is(convert('target'), 'target');
  t.is(convert('title'), 'title');
  t.is(convert('type'), 'type');
  t.is(convert('usemap'), 'useMap');
  t.is(convert('value'), 'value');
  t.is(convert('width'), 'width');
  t.is(convert('wmode'), 'wmode');
  t.is(convert('wrap'), 'wrap');
  t.is(convert('clippath'), 'clipPath');
  t.is(convert('cx'), 'cx');
  t.is(convert('cy'), 'cy');
  t.is(convert('d'), 'd');
  t.is(convert('dx'), 'dx');
  t.is(convert('dy'), 'dy');
  t.is(convert('fill'), 'fill');
  t.is(convert('fillopacity'), 'fillOpacity');
  t.is(convert('fontfamily'), 'fontFamily');
  t.is(convert('fontsize'), 'fontSize');
  t.is(convert('fx'), 'fx');
  t.is(convert('fy'), 'fy');
  t.is(convert('gradienttransform'), 'gradientTransform');
  t.is(convert('gradientunits'), 'gradientUnits');
  t.is(convert('markerend'), 'markerEnd');
  t.is(convert('markermid'), 'markerMid');
  t.is(convert('markerstart'), 'markerStart');
  t.is(convert('offset'), 'offset');
  t.is(convert('opacity'), 'opacity');
  t.is(convert('patterncontentunits'), 'patternContentUnits');
  t.is(convert('patternunits'), 'patternUnits');
  t.is(convert('points'), 'points');
  t.is(convert('preserveaspectratio'), 'preserveAspectRatio');
  t.is(convert('r'), 'r');
  t.is(convert('rx'), 'rx');
  t.is(convert('ry'), 'ry');
  t.is(convert('spreadmethod'), 'spreadMethod');
  t.is(convert('stopcolor'), 'stopColor');
  t.is(convert('stopopacity'), 'stopOpacity');
  t.is(convert('stroke'), 'stroke');
  t.is(convert('strokedasharray'), 'strokeDasharray');
  t.is(convert('strokelinecap'), 'strokeLinecap');
  t.is(convert('strokeopacity'), 'strokeOpacity');
  t.is(convert('strokewidth'), 'strokeWidth');
  t.is(convert('textanchor'), 'textAnchor');
  t.is(convert('transform'), 'transform');
  t.is(convert('version'), 'version');
  t.is(convert('viewbox'), 'viewBox');
  t.is(convert('x1'), 'x1');
  t.is(convert('x2'), 'x2');
  t.is(convert('x'), 'x');
  t.is(convert('xlink:actuate'), 'xlinkActuate');
  t.is(convert('xlink:arcrole'), 'xlinkArcrole');
  t.is(convert('xlink:href'), 'xlinkHref');
  t.is(convert('xlink:role'), 'xlinkRole');
  t.is(convert('xlink:show'), 'xlinkShow');
  t.is(convert('xlink:title'), 'xlinkTitle');
  t.is(convert('xlink:type'), 'xlinkType');
  t.is(convert('xml:base'), 'xmlBase');
  t.is(convert('xml:lang'), 'xmlLang');
  t.is(convert('xml:space'), 'xmlSpace');
  t.is(convert('y1'), 'y1');
  t.is(convert('y2'), 'y2');
  t.is(convert('y'), 'y');
  t.is(convert('oncopy'), 'onCopy');
  t.is(convert('oncut'), 'onCut');
  t.is(convert('onpaste'), 'onPaste');
  t.is(convert('oncompositionend'), 'onCompositionEnd');
  t.is(convert('oncompositionstart'), 'onCompositionStart');
  t.is(convert('oncompositionupdate'), 'onCompositionUpdate');
  t.is(convert('onkeydown'), 'onKeyDown');
  t.is(convert('onkeypress'), 'onKeyPress');
  t.is(convert('onkeyup'), 'onKeyUp');
  t.is(convert('onfocus'), 'onFocus');
  t.is(convert('onblur'), 'onBlur');
  t.is(convert('onchange'), 'onChange');
  t.is(convert('oninput'), 'onInput');
  t.is(convert('onsubmit'), 'onSubmit');
  t.is(convert('onclick'), 'onClick');
  t.is(convert('oncontextmenu'), 'onContextMenu');
  t.is(convert('ondoubleclick'), 'onDoubleClick');
  t.is(convert('ondrag'), 'onDrag');
  t.is(convert('ondragend'), 'onDragEnd');
  t.is(convert('ondragenter'), 'onDragEnter');
  t.is(convert('ondragexit'), 'onDragExit');
  t.is(convert('ondragleave'), 'onDragLeave');
  t.is(convert('ondragover'), 'onDragOver');
  t.is(convert('ondragstart'), 'onDragStart');
  t.is(convert('ondrop'), 'onDrop');
  t.is(convert('onmousedown'), 'onMouseDown');
  t.is(convert('onmouseenter'), 'onMouseEnter');
  t.is(convert('onmouseleave'), 'onMouseLeave');
  t.is(convert('onmousemove'), 'onMouseMove');
  t.is(convert('onmouseout'), 'onMouseOut');
  t.is(convert('onmouseover'), 'onMouseOver');
  t.is(convert('onmouseup'), 'onMouseUp');
  t.is(convert('onselect'), 'onSelect');
  t.is(convert('ontouchcancel'), 'onTouchCancel');
  t.is(convert('ontouchend'), 'onTouchEnd');
  t.is(convert('ontouchmove'), 'onTouchMove');
  t.is(convert('ontouchstart'), 'onTouchStart');
  t.is(convert('onscroll'), 'onScroll');
  t.is(convert('onwheel'), 'onWheel');
  t.is(convert('onabort'), 'onAbort');
  t.is(convert('oncanplay'), 'onCanPlay');
  t.is(convert('oncanplaythrough'), 'onCanPlayThrough');
  t.is(convert('ondurationchange'), 'onDurationChange');
  t.is(convert('onemptied'), 'onEmptied');
  t.is(convert('onencrypted'), 'onEncrypted');
  t.is(convert('onended'), 'onEnded');
  t.is(convert('onerror'), 'onError');
  t.is(convert('onloadeddata'), 'onLoadedData');
  t.is(convert('onloadedmetadata'), 'onLoadedMetadata');
  t.is(convert('onloadstart'), 'onLoadStart');
  t.is(convert('onpause'), 'onPause');
  t.is(convert('onplay'), 'onPlay');
  t.is(convert('onplaying'), 'onPlaying');
  t.is(convert('onprogress'), 'onProgress');
  t.is(convert('onratechange'), 'onRateChange');
  t.is(convert('onseeked'), 'onSeeked');
  t.is(convert('onseeking'), 'onSeeking');
  t.is(convert('onstalled'), 'onStalled');
  t.is(convert('onsuspend'), 'onSuspend');
  t.is(convert('ontimeupdate'), 'onTimeUpdate');
  t.is(convert('onvolumechange'), 'onVolumeChange');
  t.is(convert('onwaiting'), 'onWaiting');
  t.is(convert('onload'), 'onLoad');
  t.is(convert('onerror'), 'onError');
});

test('convert supported attributes with capital letters', t => {
  t.is(convert('ACCEPT'), 'accept');
  t.is(convert('ACTION'), 'action');
  t.is(convert('classID'), 'classID');
  t.is(convert('CLAss'), 'className');
});

test('bypass unsupported attributes', t => {
  t.is(convert('data-test'), 'data-test');
  t.is(convert('aria-label'), 'aria-label');
  t.is(convert('unsupported-attr'), 'unsupported-attr');
});
